package utils

import (
	"github.com/astaxie/beego/config"
	"github.com/kinisky564477/wechat/component"
)

// Component 微信开放平台
var Component *component.ComponentClient

// ComponentInit 第三方初始化
func ComponentInit() {
	// 初始化第三方
	var cert map[string]string
	wechat, _ := config.NewConfig("ini", appRoot+"/conf/db.conf")
	cert["component_appid"] = wechat.String("appid")
	cert["aeskey"] = wechat.String("aeskey")
	Component = component.NewComponentClient(cert)
}

// RefreshComponentTicket ticket
func RefreshComponentTicket(ticket string) {
	Component.RefreshTicket(ticket)
}

// WechatInit 微信初始化
func WechatInit(cert map[string]string) *component.WxClient {
	var wechatClient *component.WxClient

	wechatClient = component.NewWxClient(
		cert,
		Component.GetToken,
		Component.GetCertificate,
	)

	return wechatClient
}

// AppendWxClient 增加微信实例
func AppendWxClient(wx *component.WxClient) {
	Component.AppendWxClient(wx)
}
